"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _reactRouter = require("react-router");

var _Modal = _interopRequireDefault(require("../Modal"));

var _propTypes = _interopRequireDefault(require("prop-types"));

require("./index.less");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * 表格上部的功能按钮
 * @param leftBtns { Array} 左边的按钮
 *                  格式：[
 *                          {
 *                            check: Function, // 是否显示该按钮
 *                            label:String, // 按钮文字
 *                            onClick: Function, // 按钮点击事件
 *                            type: String, // 按钮点击事件,值为btn(默认值)，link， import
 *                            checkUsable: Function()=> * , // 点击按钮全的检查，返回为非空字符串时，进行提示，为空时，触发点击事件
 *                            confirm: {
 *                              text: String, // 确认提示文字
 *                              onOk: Function, // 确认
 *                              onCancel: Function, // 取消
 *                            }, // 按钮点击事件
 *                          }
 *                        ]
 * @param rightBtns { Array} 右边的按钮  数据格式同 leftBtns
 *
 *
 */
var TableBtns = /*#__PURE__*/function (_Component) {
  _inherits(TableBtns, _Component);

  var _super = _createSuper(TableBtns);

  function TableBtns(props) {
    var _this;

    _classCallCheck(this, TableBtns);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "controlConfirm", function (confirm) {
      var confirmVisible = _this.state.confirmModal.confirmVisible; // 提示语

      var text = ''; // text 为函数时

      if (typeof confirm.text === 'function') {
        text = confirm.text();
      } else {
        text = confirm.text;
      }

      _this.setState({
        confirmModal: _objectSpread(_objectSpread({
          confirmVisible: !confirmVisible
        }, confirm), {}, {
          text: text
        })
      });
    });

    _defineProperty(_assertThisInitialized(_this), "onOk", function () {
      var onOk = _this.state.confirmModal.onOk;
      onOk && onOk();

      _this.controlConfirm({
        confirmVisible: false
      });
    });

    _defineProperty(_assertThisInitialized(_this), "onCancel", function () {
      var onCancel = _this.state.confirmModal.onCancel;
      onCancel && onCancel();

      _this.controlConfirm({
        confirmVisible: false
      });
    });

    _defineProperty(_assertThisInitialized(_this), "checkUsable", function (text, callback) {
      if (!text) {
        // text 值为为false时，进行点击事件回调
        return callback();
      } else if (typeof text === 'string' && text) {
        // 有文字时，进行文字提示，不在进行点击回调
        _antd.message.info(text);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "renderBtn", function (btn, i, className) {
      var disabled = btn.disabled || false;
      var text = btn.checkUsable; // 更具返回的值，判断是否给出点击按钮之前的提示

      if (typeof btn.checkUsable === 'function') {
        text = btn.checkUsable();
      }

      if (btn.type === 'link') {
        return /*#__PURE__*/_react["default"].createElement(_reactRouter.Link, {
          className: "right-link",
          to: btn.href
        }, " ", /*#__PURE__*/_react["default"].createElement(_antd.Button, {
          className: className,
          type: "primary",
          key: "".concat(btn.label).concat(i)
        }, btn.label));
      }

      var callback = function callback() {
        return btn.confirm ? _this.controlConfirm(btn.confirm) : btn.onClick();
      };

      if (btn.type === 'import') {
        return /*#__PURE__*/_react["default"].createElement("div", {
          key: "".concat(btn.label).concat(i),
          className: "left-btn-file"
        }, /*#__PURE__*/_react["default"].createElement("input", {
          type: "file",
          name: "file",
          accept: btn.accept,
          id: btn.id,
          onChange: btn.onClick,
          key: Math.random()
        }), /*#__PURE__*/_react["default"].createElement(_antd.Button, {
          type: "primary",
          className: className,
          disabled: disabled
        }, btn.label));
      }

      return /*#__PURE__*/_react["default"].createElement(_antd.Button, {
        type: "primary",
        className: className,
        key: "".concat(btn.label).concat(i),
        onClick: function onClick() {
          return _this.checkUsable(text, callback);
        },
        disabled: disabled
      }, btn.label);
    });

    _defineProperty(_assertThisInitialized(_this), "check", function (_ref) {
      var check = _ref.check;

      // console.log(check)
      if (typeof check === 'undefined') {
        return true;
      } else if (typeof check === 'boolean') {
        return check;
      } else if (typeof check === 'function') {
        return check();
      }

      return true;
    });

    _this.state = {
      confirmModal: {
        // 确认弹窗的显示
        confirmVisible: false,
        text: ''
      }
    };
    return _this;
  }

  _createClass(TableBtns, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          leftBtns = _this$props.leftBtns,
          rightBtns = _this$props.rightBtns;
      var _this$state$confirmMo = this.state.confirmModal,
          confirmVisible = _this$state$confirmMo.confirmVisible,
          text = _this$state$confirmMo.text; //todo 此处Modal待公共confirm组件完成之后替换该Modal 组件

      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "table-btn"
      }, /*#__PURE__*/_react["default"].createElement(_Modal["default"], {
        type: "confirm" // title=" "
        ,
        visible: confirmVisible,
        oktext: "\u786E\u8BA4",
        onConfirm: this.onOk,
        onClose: this.onCancel
      }, /*#__PURE__*/_react["default"].createElement("p", {
        className: "confirm-text"
      }, text)), /*#__PURE__*/_react["default"].createElement("div", {
        className: "left-btn"
      }, leftBtns.filter(this.check).map(function (btn, i) {
        return _this2.renderBtn(btn, i, 'btn-left');
      })), /*#__PURE__*/_react["default"].createElement("div", {
        className: "right-btn"
      }, rightBtns.length ? /*#__PURE__*/_react["default"].createElement("span", {
        className: "label"
      }, "\u6279\u91CF\u64CD\u4F5C\uFF1A") : null, rightBtns.filter(this.check).map(function (btn, i) {
        return _this2.renderBtn(btn, i, 'btn-right');
      })));
    }
  }]);

  return TableBtns;
}(_react.Component);

exports["default"] = TableBtns;

_defineProperty(TableBtns, "defaultProps", {
  leftBtns: [],
  rightBtns: []
});

_defineProperty(TableBtns, "propTypes", {
  leftBtns: _propTypes["default"].array,
  rightBtns: _propTypes["default"].array
});