"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.findNodeByStringID = findNodeByStringID;
exports.findFirstLeafNode = findFirstLeafNode;
exports.timeStampToTime = timeStampToTime;
exports.thousandsSwitch = thousandsSwitch;
exports.openBrowserTag = exports.compareTimeInterval = exports.getCompareArray = exports.getDeleteExcluedItem = exports.getAddExcluedItem = exports.uniqSelectRows = exports.setTableIndex = exports.splitStrToNum = exports.toSBC = exports.getTreeToData = exports.calculateFileSize = exports.endTimeStamp = exports.startTimeStamp = exports.arrayToString = exports.removeEmpty = exports.generateRules = exports.getAfterDeletePage = exports.getDisabledMonth = exports.getDisabledWeek = exports.replaceURLParam = exports.replaceAliasName = exports.cache = exports.updateTabsState = exports.removeCriteria = exports.getCaches = exports.evalSearchParam = exports.cacheSearchParameter = exports.sortObjByKey = exports.emptyFilter = exports.isEmpty = exports.compareIp = exports.compareNum = exports._decodeURIComponent = exports.transliteration = exports.disabledDateTime = exports.subNodeQuery = exports.findSubNodeStringIds = exports.foreachNode = exports.strUnescape = exports.flowSwitch = exports.ellipsisFilter = exports.download = exports.TooltipFun = exports.TooltipFn = exports.timeFilter = exports.analysisUrl = void 0;

var _qs = _interopRequireDefault(require("qs"));

var _moment = _interopRequireDefault(require("moment"));

var _lodash = _interopRequireDefault(require("lodash"));

var _antd = require("antd");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

/**
 * 解析URL中的参数
 * @param {String} url
 * @returns {{}}
 */
var analysisUrl = function analysisUrl(url) {
  if (!url || !url.includes('?')) return {};
  var init = {};
  var Arr = url.split('?')[1].split('&');

  var _iterator = _createForOfIteratorHelper(Arr),
      _step;

  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var i = _step.value;
      var arr = i.split('=');
      var key = arr[0];
      var value = arr[1]; // 属于这些参数就进行解码

      var decodeURIID = ['areaId', 'relId', 'id', 'stringId', 'categoryModel', 'categoryModelId', 'categoryId', 'assetId', 'taskId', 'primaryKey', 'flowId', 'planId', 'asset', 'workOrderId', 'orderId'];

      if (decodeURIID.includes(key)) {
        init[key] = value ? decodeURIComponent(value) : '';
      } else {
        init[key] = value;
      }
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }

  return init;
}; //时间数据重组


exports.analysisUrl = analysisUrl;

var timeFilter = function timeFilter(values) {
  if (values.time && values.time.length) {
    values.beginTime = values.time[0] ? values.time[0].valueOf() + '' : '';
    values.endTime = values.time[1] ? values.time[1].valueOf() + '' : '';
    delete values.time;
  }
};
/** 气泡
 * @param {(string|string[])}text 要显示的内容
 */


exports.timeFilter = timeFilter;

var TooltipFn = function TooltipFn(text) {
  // typeof text!=='object'
  if (Object.prototype.toString.call(text) === '[object Array]') {
    return text.map(function (item, i) {
      return /*#__PURE__*/React.createElement(_antd.Tooltip, {
        getPopupContainer: function getPopupContainer(triggerNode) {
          return triggerNode.parentNode;
        },
        placement: "topLeft",
        title: item,
        key: i
      }, i !== 0 && '/', emptyFilter(item));
    });
  }

  return /*#__PURE__*/React.createElement(_antd.Tooltip, {
    getPopupContainer: function getPopupContainer(triggerNode) {
      return triggerNode.parentNode;
    },
    placement: "topLeft",
    title: text
  }, emptyFilter(text));
};
/** 特列 表格里面显示第一个ip,气泡里面全部显示
 * @param text 要显示的内容
 */


exports.TooltipFn = TooltipFn;

var TooltipFun = function TooltipFun(text) {
  var arr = text.split(',');
  return /*#__PURE__*/React.createElement(_antd.Tooltip, {
    getPopupContainer: function getPopupContainer(triggerNode) {
      return triggerNode.parentNode;
    },
    placement: "topLeft",
    title: text
  }, emptyFilter(arr[0]));
};
/**
 * 执行下载
 * @method download
 * @param  {String} url 下载地址，从/xxx开始
 * @param  {Object} values 下载参数
 */


exports.TooltipFun = TooltipFun;

var download = function download(url, values) {
  var params = {};

  if (!values) {
    values = {};
  }

  var headers = createHeaders(values); // url中，token的键名为access_token

  headers.access_token = sessionStorage.getItem('token');
  delete headers.Authorization;
  params = Object.assign(headers, values);
  window.open(url + '?' + _qs["default"].stringify(params));
};

exports.download = download;

var ellipsisFilter = function ellipsisFilter(str, maxLength) {
  if (str && str.length > maxLength) return "".concat(str.substr(0, maxLength), "...");
  return str;
};
/**
 * 流量转换
 * @param num {Number} 文件大小 单位为 字节 b
 * @param unit {String} 要输出的转换单位
 * @return {String|undefined}
 */


exports.ellipsisFilter = ellipsisFilter;

var flowSwitch = function flowSwitch(num) {
  var unit = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'MB';
  var switchArr = ['B', 'KB', 'MB', 'GB'];
  var index = switchArr.findIndex(function (e) {
    return e === unit.toUpperCase();
  }); // 没有找到对应的单位时

  if (index === -1) {
    return;
  } else if (index === 0) {
    return "".concat(num).concat(switchArr[0]);
  }

  var newNum = num;

  for (var i = 0; i < index; ++i) {
    newNum = newNum / 1024;

    if (newNum < 1000) {
      index = i + 1;
      break;
    }
  }

  return "".concat(parseInt(newNum, 10) === newNum ? parseInt(newNum, 10) : newNum.toFixed(2)).concat(switchArr[index]);
}; // 字符串反转义


exports.flowSwitch = flowSwitch;

var strUnescape = function strUnescape(str) {
  if (!str) {
    return str;
  } else {
    var result = _lodash["default"].unescape(str);

    return result;
  }
};
/**
 * 查找节点树
 * @param data {Object} 资产类型树
 * @param stringId {String} 节点ID
 * @returns rootNode {Object} 节点树
 */


exports.strUnescape = strUnescape;

function findNodeByStringID(data, stringId) {
  //此处 findNodeList 充当队列的作用
  var findNodeList = [];
  findNodeList.push(data);

  while (findNodeList.length > 0) {
    var rootNode = findNodeList[0];

    if (rootNode.stringId === stringId) {
      return rootNode;
    } //清除队列中的第一个元素


    findNodeList.shift();
    var childrenNode = rootNode.childrenNode;

    if (childrenNode) {
      childrenNode.forEach(function (item) {
        findNodeList.push(item);
      });
    }
  }
}
/**
 * 查找数组的第一个元素的最末级节点
 * @param data {Array} 资产类型树
 * @param childKey {String} 节点子集的key
 * @returns rootNode {Object} 节点树
 */


function findFirstLeafNode(data) {
  var childKey = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'childrenNode';
  //此处 findNodeList 充当队列的作用
  var findNodeList = [].concat(data);

  while (findNodeList.length > 0) {
    var currentNode = findNodeList[0];

    if (!currentNode[childKey] || !currentNode[childKey].length) {
      return currentNode;
    } //清除队列中的第一个元素


    findNodeList.shift(); // 只有一个子节点，进行往下查找

    if (currentNode[childKey].length === 1) {
      // 把子集的第一个元素加入队列
      findNodeList.push(currentNode[childKey][0]);
    }
  }
}
/**
 * 递归获取节点下所有子节点ID
 * @param rootNode {Object} 节点树
 * @param handler {Function}
 */


var foreachNode = function foreachNode(rootNode, handler) {
  if (handler) {
    handler(rootNode);
  }

  var childrenNode = rootNode.childrenNode;

  if (childrenNode) {
    childrenNode.forEach(function (item) {
      foreachNode(item, handler);
    });
  }
};
/**
 * 查找节点下所有子节点
 * @param data {Object} 资产类型树
 * @param stringId {String}
 * @returns stringIdArr {Array} 子节点ID的集合
 */


exports.foreachNode = foreachNode;

var findSubNodeStringIds = function findSubNodeStringIds(data, stringId) {
  var stringIdArr = [];
  var findNodeData = findNodeByStringID(data, stringId);

  if (findNodeData) {
    foreachNode(findNodeData, function (nodeData) {
      stringIdArr.push(nodeData.stringId);
    });
  }

  return stringIdArr;
};
/**
 * 查找节点下所有子节点升级
 * @param data {Object} 资产类型树
 * @param arr {Array}
 * @returns stringIdArr {Array} 子节点ID的集合
 */
// function flattenDeep (arr) {
//   return arr.reduce((acc, val) => Array.isArray(val) ? acc.concat(flattenDeep(val)) : acc.concat(val), [])
// }


exports.findSubNodeStringIds = findSubNodeStringIds;

var subNodeQuery = function subNodeQuery(data) {
  return function (arr) {
    if (data && arr) {
      return _toConsumableArray(arr.map(function (item) {
        return findSubNodeStringIds(data, item);
      })).flat(Infinity); // return flattenDeep([...arr.map(item=>findSubNodeStringIds(data, item))])
    }

    return void 0;
  };
};
/**
 * 生成时分秒
 * @param {Number} start
 * @param {Number} end
 * @returns {Array}
 */


exports.subNodeQuery = subNodeQuery;

function range(start, end) {
  var result = [];

  for (var i = start; i < end; i++) {
    result.push(i);
  }

  return result;
}
/**
 * 禁用今天24点以前的未来时分秒
 * @param {Object} current (moment对象)
 * @returns {Object}
 */


var disabledDateTime = function disabledDateTime(current) {
  //启用今天以前的时分秒
  if ((0, _moment["default"])(current).isBefore(new Date()) && !(0, _moment["default"])(current).isSame(new Date(), 'day')) {
    return {};
  }

  var clickHours = new Date(current).getHours();
  var clickMinutes = new Date(current).getMinutes();
  var hours = (0, _moment["default"])().hours(); //0~23

  var minutes = (0, _moment["default"])().minutes(); //0~59

  var seconds = (0, _moment["default"])().second(); //0~59
  //当日只能选择当前时间之后的时间点

  return {
    disabledHours: function disabledHours() {
      return range(hours + 1, 24);
    },
    disabledMinutes: function disabledMinutes() {
      return clickHours < hours ? [] : range(minutes + 1, 60);
    },
    disabledSeconds: function disabledSeconds() {
      return clickHours < hours || clickMinutes < minutes ? [] : range(seconds, 60);
    }
  };
};
/**
 * 转码uri, 不对 空('', null, undefind) 进行转换，直接返回空的 ''
 * @param str{ String} 要转义的字符串
 * @return {String} 转换过后的字符串
 */


exports.disabledDateTime = disabledDateTime;

var transliteration = function transliteration(str) {
  if (typeof str === 'number') {
    console.warn('参数是数字，将被强制转换为字符串输出');
    return "".concat(str);
  }

  return str ? encodeURIComponent(str) : '';
};
/**
 * 解码uri, 不对 空('', null, undefind) 进行转换，直接返回空的 ''
 * @param str{ String} 要解码的字符串
 * @return {String} 解码过后的字符串
 */


exports.transliteration = transliteration;

var _decodeURIComponent = function _decodeURIComponent(str) {
  return str ? decodeURIComponent(str) : '';
};
/**
 *  第一个参数与第二个参数比较情况，返回 > |  = | <
 * @param value1Num {String} 整数字符串
 * @param value2Num {String} 整数字符串
 * @return { String } > |  = | <
 */


exports._decodeURIComponent = _decodeURIComponent;

var ratio = function ratio() {
  var value1Num = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var value2Num = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  var index1 = value1Num.length;
  var index2 = value2Num.length;

  if (index2 > index1) {
    var _arr = value2Num.slice(index1).split('');

    _arr.forEach(function () {
      value1Num = '0' + value1Num;
    });
  }

  if (index2 < index1) {
    var _arr2 = value1Num.slice(index2).split('');

    _arr2.forEach(function () {
      value2Num = '0' + value2Num;
    });
  }

  var i = 0;

  while (i !== value2Num.length) {
    if (Number(value1Num[i]) > Number(value2Num[i])) {
      // console.log('开始值必须小于结束值')
      return '>';
    }

    if (Number(value1Num[i]) < Number(value2Num[i])) {
      // console.log('开始值必须小于结束值')
      return '<';
    }

    ++i;
  }

  return '=';
}; // const rege = /^([0-9]*(\.\d{1,3})?)$/

/**
 * 超大数字比较大小
 * @param  value1 {String|Number} -ip
 * @param  value2 {String|Number} -ip
 * @return {String|string}  小于返回<  等于返回=  大于返回>
 */


var compareNum = function compareNum() {
  var value1 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var value2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';

  // const value1 = '12345678901234567890.1'
  // const value2 = '12345678901234567891'
  if (value1 === value2) {
    return '=';
  }

  var _value1 = value1.split('.');

  var _value2 = value2.split('.'); // 开始值得整数部分


  var value1Num = _value1[0]; // 结束值的整数部分

  var value2Num = _value2[0]; // 比较整数部分的大小，开始值大于结束值

  if (value1Num.length > value2Num.length) {
    return '>';
  } else {
    // 比较第一个开始值整数是否大于结束值整数
    var flag = ratio(value1Num, value2Num);

    if (flag === '>') {
      return '>';
    }

    if (flag === '=') {
      /**
       * 整数相等等情况，比较小数
       * @type {string | string}
       */
      // 开始值得小数部分
      var value1Float = _value1[1] || '0'; // 结束值的小数部分

      var value2Float = _value2[1] || '0'; // 比较开始值小数是否大于结束值小数

      var flagFloat = ratio(value1Float, value2Float);
      return flagFloat;
    }

    return '<';
  }
};
/**
 * ip比较大小
 * @param {string} ip1
 * @param {string} ip2
 * @return {Boolean} -返回true,标识
 */


exports.compareNum = compareNum;

var compareIp = function compareIp() {
  var ip1 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var ip2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';

  // const ip1 = '192.168.5.1'
  // const ip2 = '192.168.2.1'
  if (ip1 && ip2) {
    if (ip1 === ip2) {
      _antd.message.error('起始值不能大于等于结束值');

      return true;
    }

    var ip1Arr = ip1.split('.');
    var ip2Arr = ip2.split('.');
    var idx = ip1Arr.length;
    var i = 0;

    while (i < idx - 1) {
      var result = ratio(ip1Arr[i], ip2Arr[i]);

      if (result !== '=') {
        _antd.message.error('IP起始值前三位应等于结束值前三位');

        return true;
      }

      ++i;
    }

    if (ratio(ip1Arr[idx - 1], ip2Arr[idx - 1]) === '>') {
      _antd.message.error('起始值不能大于等于结束值');

      return true;
    }

    return false;
  }
};
/* 判断内容是否为空
 * @param s 要判断的内容
 * @return Boolean
 */


exports.compareIp = compareIp;

var isEmpty = function isEmpty(s) {
  return s === null || typeof s === 'undefined' || typeof s === 'string' && s.replace(/\s*/g, '') === '' || s === 'null/null' || s === 'null';
};
/* 判断内容是否为空，为空显示占位符
 * @param str 要判断的内容
 * @return str 返回实际显示的内容
 */


exports.isEmpty = isEmpty;

var emptyFilter = function emptyFilter(str) {
  if (isEmpty(str)) return '--';
  return str;
};
/**
 * json按属性名key来排序
 * @param obj 待排序的json
 * @return newObj 排序后的json
 */


exports.emptyFilter = emptyFilter;

var sortObjByKey = function sortObjByKey(obj) {
  var keys = Object.keys(obj).sort();
  var newObj = {};

  for (var i = 0; i < keys.length; i++) {
    var index = keys[i];

    if (obj[index]) {
      newObj[index] = obj[index];
    }
  }

  return newObj;
};
/**
 * 保留搜索条件 和页码
 * @param list 当前页 page和param 的数组集合
 * @param pageIndex {history} 当前页路由name
 * @param mark (number)当前页面如果有多个表单和页码需要存储，作为标识（从0开始计算）
 * @param tagKey {string<number>} 如果存在多个标签页，作为存储范围的标识
 */


exports.sortObjByKey = sortObjByKey;

var cacheSearchParameter = function cacheSearchParameter(lists, pageIndex) {
  var mark = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
  var tagKey = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
  var init = {
    list: [],
    pageIndex: pageIndex ? pageIndex.location.pathname : ''
  }; //当前页面list中是否有值

  var classify = function classify(item, n) {
    if (tagKey !== null) lists[0].tagKey = tagKey;
    if (mark === null) item = lists;else item[n] = lists[0];
    return item;
  }; //是否tab标签页


  var multilayer = function multilayer(arr) {
    if (!tagKey) return arr;
    arr.forEach(function (item) {
      return item.tagKey = tagKey;
    });
    return arr;
  }; //判斷是否存在sessionStorage


  if (sessionStorage.searchParameter) {
    var arr = JSON.parse(sessionStorage.searchParameter); //如果沒有跟当前页面name名称相等，就add

    if (arr.every(function (n) {
      return n.pageIndex !== pageIndex.location.pathname;
    })) {
      if (mark !== null) init.list = classify(init.list, mark);else init.list = multilayer(lists);
      arr.push(init);
    } else {
      //在数组的位置
      var n = arr.findIndex(function (el) {
        return el.pageIndex === pageIndex.location.pathname;
      });

      if (mark !== null) {
        arr[n].list = classify(arr[n].list, mark);
      } else {
        arr[n].list = multilayer(lists);
      }
    }

    sessionStorage.setItem('searchParameter', JSON.stringify(arr));
  } else {
    if (mark !== null) init.list = classify(init.list, mark);else init.list = multilayer(lists);
    sessionStorage.setItem('searchParameter', JSON.stringify([init]));
  }
};
/**
 * 解析sessionStorage
 * @param parent 传来的this
 * @param obj 额外的请求参数
 * @param autoSet { Boolean } 是否自动设置
 *
 * 备注：如果要给form设置数据，为空或null时请操作合适的数据格式，否则会有意外的界面显示
 */


exports.cacheSearchParameter = cacheSearchParameter;

var evalSearchParam = function evalSearchParam(parent) {
  var obj = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  var autoSet = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
  //没有sessionStorage时 直接抛出去
  if (!sessionStorage.searchParameter) return void 0;
  var init = JSON.parse(sessionStorage.searchParameter);
  var result = {};
  init.forEach(function (ob) {
    if (ob.pageIndex === parent.props.history.location.pathname) {
      var list = ob.list;
      var v = ['gmtCreateStart', 'gmtCreateEnd', 'enterNetStart', 'time', 'enterNetEnd', 'beginTime', 'endTime', 'releaseStartTime', 'releaseEndTime', 'writeTime', 'auditTime'];
      result = JSON.parse(JSON.stringify(ob)); //遍历

      list.forEach(function (item) {
        //如果为空不执行
        if (item === null) return void 0; //保留的参数项

        var parameter = item.parameter;

        var _loop = function _loop(now) {
          if (v.includes(now) && parameter[now]) {
            // 时间为 range时
            if (Array.isArray(parameter[now])) {
              parameter[now].forEach(function (ele, idx) {
                ele && (parameter[now][idx] = (0, _moment["default"])((0, _moment["default"])(ele).format('YYYY-MM-DD')));
              });
            } else {
              parameter[now] = (0, _moment["default"])((0, _moment["default"])(parameter[now]).format('YYYY-MM-DD'));
            }
          }
        };

        for (var now in parameter) {
          _loop(now);
        }

        if (parameter && parameter.currentPage && parameter.pageSize) {
          delete parameter.currentPage;
          delete parameter.pageSize;
        } // 回显并且设置查询


        autoSet && parent.props.form.setFieldsValue(_objectSpread(_objectSpread({}, parameter), obj));
      });
    }
  });
  if (JSON.stringify(result) === '{}') return void 0;
  return result;
};
/**
 * 获取缓存，有缓存返回缓存对象，没有的话，返回 undefined
 * @param parent 调用改函数的组件的this对象
 * @param autoSet { Boolean } 是否自动设置
 * @param searchIndex { Number } 路由下的第几个缓存数据，为undefind 时，返回整个路由下的缓存列表 返回为数组结构array，为数字时，返回的是路由下下标为 searchIndex 的缓存，返回的为对象结构
 * @return {boolean|array|*}
 */


exports.evalSearchParam = evalSearchParam;

var getCaches = function getCaches(parent) {
  var autoSet = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
  var searchIndex = arguments.length > 2 ? arguments[2] : undefined;

  if (!sessionStorage.searchParameter) {
    return undefined;
  }

  var cache = evalSearchParam(parent, {}, autoSet); // 有缓存时

  if (cache && cache.list && cache.list.length) {
    // searchIndex  为null 或者 undefined时，返回该路由下的全部缓存
    if (!searchIndex && searchIndex !== 0) {
      return cache.list;
    }

    var first = cache.list[searchIndex];

    if (!first) {
      return undefined;
    }

    var page = Object.keys(first.page);
    var parameter = Object.keys(first.parameter);
    var menuActive = first.menuActive && Object.keys(first.menuActive); // 有分页缓存或者参数缓存时,返回参数缓存对象

    if (parameter.length || page.length || menuActive) {
      return first;
    } else {
      return undefined;
    }
  }

  return false;
};
/**
 *@param tagKey {string|number} 根据标识局部删除
 *@param pageIndex {history} 路由
 */
//清除sessionStorage缓存条件，并取消工作台状态


exports.getCaches = getCaches;

var removeCriteria = function removeCriteria() {
  var tagKey = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
  var pageIndex = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

  if (tagKey) {
    var iData = JSON.parse(sessionStorage.getItem('searchParameter'));

    if (iData) {
      var index = iData.findIndex(function (el) {
        return el.pageIndex === pageIndex.location.pathname;
      });
      iData[index] && iData[index].list.forEach(function (item, i) {
        if (item && item.tagKey === tagKey) iData[index].list[i] = null;
      });
      sessionStorage.setItem('searchParameter', JSON.stringify(iData));
    }
  } else {
    sessionStorage.removeItem('searchParameter');
    sessionStorage.works = 0;
  }
};
/** 标签页选中状态
 * @param active {string | number} tabs标签页的选项状态
 * @param pageIndex {history} 路由
 */


exports.removeCriteria = removeCriteria;

var updateTabsState = function updateTabsState(active, pageIndex) {
  if (!sessionStorage.searchParameter) {
    sessionStorage.searchParameter = JSON.stringify([{
      list: [],
      pageIndex: pageIndex.location.pathname,
      active: active
    }]);
  } else {
    var iData = JSON.parse(sessionStorage.searchParameter);
    var index = iData.findIndex(function (el) {
      return el.pageIndex === pageIndex.location.pathname;
    });

    if (index !== -1) {
      iData[index].active = active;
      sessionStorage.searchParameter = JSON.stringify(iData);
    }
  }
};
/*
 * 缓存对象
*/


exports.updateTabsState = updateTabsState;
var cache = {
  evalSearchParam: evalSearchParam,
  cacheSearchParameter: cacheSearchParameter,
  getCaches: getCaches,
  removeCriteria: removeCriteria,
  updateTabsState: updateTabsState
};
/**
 * 替换Form中的别名
 * @param values 待替换的form values
 * @return 替换后的values
 */

exports.cache = cache;

var replaceAliasName = function replaceAliasName(values) {
  Object.keys(values).forEach(function (item) {
    if (item.includes('alias-')) {
      var key = item.replace('alias-', '');
      values[key] = values[item];
      delete values[item];
    }
  });
  return values;
};
/**
 * 替换路由中的参数
 * @param urlParams url地址的参数 格式：?a=1&b=2
 * @param param { Object } 待替换的参数
 * @return { string }
 */


exports.replaceAliasName = replaceAliasName;

var replaceURLParam = function replaceURLParam(urlParams) {
  var param = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var init = {};
  var search = urlParams.split('?')[1];

  if (search) {
    var Arr = search.split('&');

    var _iterator2 = _createForOfIteratorHelper(Arr),
        _step2;

    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
        var i = _step2.value;
        var arr = i.split('=');
        var key = arr[0];
        var value = arr[1]; // 属于这些参数就进行解码

        var decodeURIID = [];

        if (decodeURIID.includes(key)) {
          init[key] = value ? decodeURIComponent(value) : '';
        } else {
          init[key] = value;
        }
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }
  }

  var _urlParam = _objectSpread(_objectSpread({}, init), param);

  var _parmas = '';
  var count = 0;

  for (var _key in _urlParam) {
    if (count === 0) {
      _parmas = "?".concat(_key, "=").concat(_urlParam[_key]);
      ++count;
      continue;
    }

    _parmas += "&".concat(_key, "=").concat(_urlParam[_key]);
  }

  return _parmas;
};
/**
 * 获取两个时间之间包含的星期
 * @param startTime 开始时间
 * @param endTime   结束时间
 * @return weekArr 包含的星期列表
 */


exports.replaceURLParam = replaceURLParam;

var getDisabledWeek = function getDisabledWeek(startTime, endTime) {
  if (!startTime || !endTime) return [];
  var weekArr = [];
  var weekDayBegin = Number((0, _moment["default"])(startTime.valueOf()).format('d'));
  var weekDayEnd = Number((0, _moment["default"])(endTime.valueOf()).format('d'));
  var t1 = weekDayBegin === 0 ? 7 : weekDayBegin;
  var t2 = weekDayEnd === 0 ? 7 : weekDayEnd;
  var diffDay = (0, _moment["default"])(endTime).diff((0, _moment["default"])(startTime), 'days'); // 计算周
  // 如果两个时间的时间差大于等于6天，便周一到周日每天都有

  if (diffDay >= 6) {
    weekArr = [1, 2, 3, 4, 5, 6, 7];
  } else {
    // 如果开始时间与结束时间在同一周
    if (t2 >= t1) {
      for (var i = t1; i <= t2; i += 1) {
        weekArr.push(i);
      }
    } // 如果开始时间与结束时间不在同一周
    else {
        for (var _i = t1; _i <= t2 + 7; _i += 1) {
          if (_i - 7 >= 1) {
            weekArr.push(_i - 7);
          } else {
            weekArr.push(_i);
          }
        }
      }
  }

  return weekArr;
};
/**
 * 获取两个时间之间包含的月份
 * @param startTime 开始时间
 * @param endTime   结束时间
 * @return weekArr 包含的月份列表
 */


exports.getDisabledWeek = getDisabledWeek;

var getDisabledMonth = function getDisabledMonth(startTime, endTime) {
  if (!startTime || !endTime) return [];
  var monthArr = [];
  var monthBegin = Number((0, _moment["default"])(startTime.valueOf()).format('M'));
  var monthEnd = Number((0, _moment["default"])(endTime.valueOf()).format('M'));
  var diffMonth = (0, _moment["default"])(endTime).diff((0, _moment["default"])(startTime), 'months'); // 计算月
  // 如果两个时间的时间差大于等于11个月，便1到12月每月都有

  if (diffMonth >= 11) {
    monthArr = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12];
  } else {
    // 如果开始时间与结束时间在同一年
    if (monthEnd >= monthBegin) {
      for (var i = monthBegin; i <= monthEnd; i += 1) {
        monthArr.push(i);
      }
    } // 如果开始时间与结束时间不在同一年
    else {
        for (var _i2 = monthBegin; _i2 <= monthEnd + 12; _i2 += 1) {
          if (_i2 - 12 >= 1) {
            monthArr.push(_i2 - 12);
          } else {
            monthArr.push(_i2);
          }
        }
      }
  }

  return monthArr;
};
/**
 * 获取删除后的当前页码，当前页不存在数据时则递减，最小至1
 * @param total {Number} 列表总条数
 * @param currentPage { Number } 当前页码
 * @param pageSize { Number } 每页条数
 * @return {Number}
 */


exports.getDisabledMonth = getDisabledMonth;

var getAfterDeletePage = function getAfterDeletePage(total, currentPage, pageSize) {
  if (Math.ceil(total / pageSize) < currentPage && currentPage !== 1) {
    return getAfterDeletePage(total, currentPage - 1, pageSize);
  }

  return currentPage;
};
/**
 * 生成验证规则
 * @param max 最多字符数
 * @param rules {Array} 验证规则
 * @returns {*[]}
 */


exports.getAfterDeletePage = getAfterDeletePage;

var generateRules = function generateRules() {
  var max = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 30;
  var rules = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  return [{
    max: max,
    message: "\u6700\u591A\u8F93\u5165".concat(max, "\u4E2A\u5B57\u7B26\uFF01")
  }, {
    whitespace: true,
    message: '不能为空字符！'
  }].concat(_toConsumableArray(rules));
};
/**
 * 删除json中为null的属性(如a:null)，数组中为null的项不删除(如a:[null])
 * 该规则是后端(王谦)要求的
 * @param obj 待删除的json
 * @return obj 删除后的json
 */


exports.generateRules = generateRules;

var deleteEmptyProp = function deleteEmptyProp(obj) {
  for (var key in obj) {
    var value = obj[key];

    if (value === null) {
      delete obj[key];
    } else if (_typeof(value) === 'object') {
      deleteEmptyProp(value);
    }
  }

  return obj;
};

var removeEmpty = function removeEmpty(obj) {
  // return Object.keys(obj).filter(key => ((typeof obj[key] !== 'boolean') && obj[key]) && obj[key] !== 'null' || typeof obj[key] === 'boolean').reduce(
  return Object.keys(obj).filter(function (key) {
    return !isEmpty(obj[key]);
  }).reduce(function (newObj, key) {
    newObj[key] = obj[key];
    return newObj;
  }, {});
};

exports.removeEmpty = removeEmpty;

var arrayToString = function arrayToString(obj) {
  return Object.keys(obj).reduce(function (newObj, key) {
    var value = obj[key];

    if (Array.isArray(value)) {
      value = value.join(',');
    }

    newObj[key] = value;
    return newObj;
  }, {});
};

exports.arrayToString = arrayToString;

function timeStampToTime(timeStamp) {
  _moment["default"].locale('zh-cn');

  return timeStamp ? (0, _moment["default"])(timeStamp).format('YYYY-MM-DD HH:mm:ss') : '--';
}

var startTimeStamp = function startTimeStamp(startTime) {
  _moment["default"].locale('zh-cn');

  return (0, _moment["default"])(startTime).format('YYYY-MM-DD 00:00:00');
};

exports.startTimeStamp = startTimeStamp;

var endTimeStamp = function endTimeStamp(endTime) {
  _moment["default"].locale('zh-cn');

  return (0, _moment["default"])(endTime).format('YYYY-MM-DD 23:59:59');
};

exports.endTimeStamp = endTimeStamp;

var calculateFileSize = function calculateFileSize(size) {
  if (size < 1024) {
    return "".concat(size, "B");
  } else if (size < 1024 * 1024) {
    return "".concat(Math.floor(size / 1024), "KB");
  } else if (size < 1024 * 1024 * 1024) {
    return "".concat(Math.floor(size / 1024 / 1024), "M");
  }
};
/**
 * 把数字转换为以{separator}分割的字符串
 * @param number {String | Number} 要进行转换的数字，或者数字类型的字符串
 * @param limit {Number} 数字分位的位数
 * @param separator {String} 数字分位的分隔符
 * @param precise 精确多少位小数
 * @return {string}
 */


exports.calculateFileSize = calculateFileSize;

function thousandsSwitch(number) {
  var limit = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 3;
  var separator = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : ',';
  var precise = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 2;
  number = number || '0';
  var unitArr = [{
    unit: '',
    length: 4,
    suffix: 0
  }, {
    unit: '万',
    length: 8,
    suffix: 4
  }, {
    unit: '亿',
    length: 12,
    suffix: 8
  }, {
    unit: '兆',
    length: 16,
    suffix: 12
  }];
  var unit = {};
  var unitIndex = 0; // 小于10000，不需要转换单位

  if (parseInt(number, 10) < 1000) {
    return "".concat(number);
  } // return number.toLocaleString('en-US')


  var numberStr = "".concat(number);
  var temp = numberStr.split(''); // 确认单位

  for (var i = 0, len = unitArr.length; i < len; ++i) {
    var _long = unitArr[i].length; // 匹配到单位或者截止到最后一个单位

    if (temp.length <= _long || i === unitArr.length - 1) {
      unit = unitArr[i];
      unitIndex = i;
      break;
    }
  }

  var result = '';
  var _float = ''; // 小数部分

  temp.reverse(); // 去除用单位代替的数字

  if (unitIndex !== 0) {
    // 精确位数必须大于0时并且精确的小数位数小于自己本身的位数，才进行精确小数
    if (precise > 0 && precise <= unit.suffix) {
      _float = temp.slice(unit.suffix - precise, unit.suffix);
      _float = "".concat(parseFloat(_float.join(''))).split('');

      _float.reverse(); // 此处必须添加0.，否者float将会被转换为整数


      _float = parseFloat('0.' + _float.join('')); //小数只有一位数，并且为0时，不显示小数

      if (_float !== 0) {
        // 保留小数并且转换为字符串
        _float = _float.toFixed(precise).slice(1);
      } else {
        _float = '';
      }
    }

    temp.splice(0, unit.suffix);
  }

  for (var start = 0; start <= temp.length;) {
    var end = start + limit;
    var arr = temp.slice(start, end);

    if (arr.length) {
      arr.reverse();
      result = separator + arr.join('') + result;
    }

    if (arr.length < limit) {
      result = result.slice(1) + _float + (unit.unit || '');
      break;
    }

    start += limit;
  }

  return result;
}
/**
 * 获取树中允许的值 笨笨的递归，因为不确定字段的值。
 * @param initTree  [] 树结构
 * @param standard  [] 允许的数组
 * @param id  当前获取的id
 */


var getTreeToData = function getTreeToData() {
  var initTree = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  return function () {
    var standard = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    return function () {
      var id = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
      var newId = null;

      if (standard.includes(id)) {
        return id;
      }

      var mapTree = function mapTree(childrenNode, id) {
        childrenNode.forEach(function (item, i) {
          if (item.stringId === id) {
            if (standard.includes(item.parentId)) {
              newId = item.parentId;
              return void 0;
            } else {
              mapTree(initTree, item.parentId);
            }
          }

          if (item.childrenNode) {
            mapTree(item.childrenNode, id);
          }
        });
      };

      mapTree(initTree, id);
      return newId;
    };
  };
};
/**
 * 全角转半角（包括全半角/部分全角/部分半角）
 * @param str  string 待转换的字符串
 */


exports.getTreeToData = getTreeToData;

var toSBC = function toSBC(str) {
  var result = '';
  var len = str.length;

  for (var i = 0; i < len; i += 1) {
    var cCode = str.charCodeAt(i);

    if (cCode > 65248 || cCode === 12288) {
      //全角与半角相差（除空格外）：65248（十进制）
      cCode = cCode >= 0xFF01 && cCode <= 0xFF5E ? cCode - 65248 : cCode; //处理空格

      cCode = cCode === 0x03000 ? 0x0020 : cCode;
    }

    result += String.fromCharCode(cCode);
  }

  return result;
};
/**
 * 把字符串转化为数字和文字
 * @param number
 * @param limit
 * @param separator
 * @return {string}
 */


exports.toSBC = toSBC;

var splitStrToNum = function splitStrToNum(changeStr) {
  var num = 0;
  var font = '';
  var boo = false;
  var Font = ['万', '亿', '兆'];
  Font.forEach(function (v) {
    return changeStr.indexOf(v) !== -1 && (boo = true);
  });

  if (boo) {
    num = changeStr.slice(0, changeStr.length - 1);
    font = changeStr.slice(-1);
  }

  if (num.indexOf('.') > -1) {
    num = "".concat(num.split('.')[0]).concat(font, "+");
  }

  num = num.replace(',', '');
  return {
    num: num,
    font: font
  };
};
/**
 * @param (当前页码，展示数量，表格的index)
 */


exports.splitStrToNum = splitStrToNum;

var setTableIndex = function setTableIndex(currentPage, pageSize, i) {
  return (currentPage - 1) * pageSize + ++i;
};
/**
 * 列表去重
 * @param selectedRows Array 列表行数据
 * @param selectedRowKeys Array  列表行数据唯一表示ID的集合
 * @param id string 去重的ID，默认为id
 * returns Array
 */


exports.setTableIndex = setTableIndex;

var uniqSelectRows = function uniqSelectRows(selectedRows, selectedRowKeys) {
  var id = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'id';
  var data = [];
  selectedRowKeys.forEach(function (item) {
    var row = selectedRows.find(function (subItem) {
      return subItem[id] === item;
    });

    if (row) {
      data.push(row);
    }
  });
  return data;
};
/**
 * 列表单选：获取取消勾选后的排除项
 * @param currentKeys Array 当前的选中项
 * @param prevKeys Array 上次的选中项
 * returns Array
 */


exports.uniqSelectRows = uniqSelectRows;

var getAddExcluedItem = function getAddExcluedItem(currentKeys, prevKeys) {
  var excluedItem = [];
  prevKeys.forEach(function (id) {
    if (!currentKeys.includes(id)) {
      excluedItem.push(id);
    }
  });
  return excluedItem;
};
/**
 * 列表单选：获取勾选后的排除项
 * @param selectedRowKeys Array 当前的选中项
 * @param excluedItem Array 已有的排除项
 * returns Array
 */


exports.getAddExcluedItem = getAddExcluedItem;

var getDeleteExcluedItem = function getDeleteExcluedItem(selectedRowKeys, excluedItem) {
  for (var i = 0; i < excluedItem.length; i++) {
    var item = excluedItem[i];

    if (selectedRowKeys.includes(item)) {
      excluedItem.splice(i, 1);
      i--;
    }
  }

  return excluedItem;
};
/**
 * 获取时间段比较数组
 * @param dataArray 时间段数组  [{start_time:'01:00',end_time:'02:00'}]
 */


exports.getDeleteExcluedItem = getDeleteExcluedItem;

var getCompareArray = function getCompareArray(dataArray) {
  var temp = Array.from({
    length: 25
  }).fill(0);
  dataArray.forEach(function (item, index) {
    var start = Number(item.start_time.split(':')[0]);
    var end = Number(item.end_time.split(':')[0]) + 1;

    _lodash["default"].fill(temp, 1, start, end);
  });
  return temp;
};
/**
 * 比较时间段
 * @param {*} pre  时间段比较数组  0-25  [1,0...1]
 * @param {*} next 时间段比较数组  0-25  [1,0...1]
 */


exports.getCompareArray = getCompareArray;

var compareTimeInterval = function compareTimeInterval(pre, next) {
  // 是否有包含 ture包含  false不包含
  var target = false;
  var temp = [];
  pre.forEach(function (item, index) {
    temp[index] = item + next[index];
  });
  target = temp.some(function (item, index) {
    var nextItem = temp[index + 1];
    return item >= 2 && nextItem && nextItem >= 2;
  }); // 不存在包含 修正比较数组

  var newCompareArray = !target ? temp.map(function (item) {
    return item >= 1 ? 1 : 0;
  }) : pre;
  return {
    target: target,
    newCompareArray: newCompareArray
  };
};
/**
 * 新开浏览器页面tag，在火狐浏览时，新开页签，可能不会带session
 * @param routeUrl
 * @param target
 */


exports.compareTimeInterval = compareTimeInterval;

var openBrowserTag = function openBrowserTag(routeUrl) {
  var target = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '_blank';
  window.open("/#/".concat(routeUrl), target);
};

exports.openBrowserTag = openBrowserTag;